/* Problem URL: https://codeforces.com/gym/105216/problem/D */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

ll mod = 1e9 + 7;
int dest = 7200;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    vvl dp(801, vl(7201 * 2));
    dp[0][dest] = 1;

    for (int i = 0; i <= 14400; i++) {
        for (int j = 1; j <= 8; j++) {
            if (i - j >= 0) {
                dp[1][i] += dp[0][i - j] * (9 - j);
            }
            if (i + j <= 14400) {
                dp[1][i] += dp[0][i + j] * (9 - j);
            }
            dp[1][i] %= mod;
        }
    }

    for (int i = 2; i <= 800; i++) {
        for (int j = 0; j <= 14400; j++) {
            for (int k = 1; k <= 9; k++) {
                if (j - k >= 0) {
                    dp[i][j] += dp[i - 1][j - k] * (10 - k);
                }
                if (j + k <= 14400) {
                    dp[i][j] += dp[i - 1][j + k] * (10 - k);
                }
                dp[i][j] %= mod;
            }
        }
    }

    int q;
    cin >> q;
    while (q--) {
        int n;
        cin >> n;

        cout << dp[n][dest] << '\n';
    }
}
